#ifndef __DDR_ADDR_H__
#define __DDR_ADDR_H__ 

#define EMIC_Base    0x000C0000

/* --- EMIC --- */
#define DENALI_CTL_00 0x000
#define DENALI_CTL_01 0x004
#define DENALI_CTL_02 0x008
#define DENALI_CTL_03 0x00C
#define DENALI_CTL_04 0x010
#define DENALI_CTL_05 0x014
#define DENALI_CTL_06 0x018
#define DENALI_CTL_07 0x01C
#define DENALI_CTL_08 0x020
#define DENALI_CTL_09 0x024
#define DENALI_CTL_10 0x028
#define DENALI_CTL_11 0x02C
#define DENALI_CTL_12 0x030
#define DENALI_CTL_13 0x034
#define DENALI_CTL_14 0x038
#define DENALI_CTL_15 0x03C
#define DENALI_CTL_16 0x040
#define DENALI_CTL_17 0x044
#define DENALI_CTL_18 0x048
#define DENALI_CTL_19 0x04C
#define DENALI_CTL_20 0x050
#define DENALI_CTL_21 0x054
#define DENALI_CTL_22 0x058
#define DENALI_CTL_23 0x05C
#define DENALI_CTL_24 0x060
#define DENALI_CTL_25 0x064
#define DENALI_CTL_26 0x068
#define DENALI_CTL_27 0x06C
#define DENALI_CTL_28 0x070
#define DENALI_CTL_29 0x074
#define DENALI_CTL_30 0x078
#define DENALI_CTL_31 0x07C
#define DENALI_CTL_32 0x080
#define DENALI_CTL_33 0x084
#define DENALI_CTL_34 0x088
#define DENALI_CTL_35 0x08C
#define DENALI_CTL_36 0x090
#define DENALI_CTL_37 0x094
#define DENALI_CTL_38 0x098
#define DENALI_CTL_39 0x09C
#define DENALI_CTL_40 0x0A0
#define DENALI_CTL_41 0x0A4
#define DENALI_CTL_42 0x0A8
#define DENALI_CTL_43 0x0AC
#define DENALI_CTL_44 0x0B0
#define DENALI_CTL_45 0x0B4
#define DENALI_CTL_46 0x0B8
#define DENALI_CTL_47 0x0BC
#define DENALI_CTL_48 0x0C0
#define DENALI_CTL_49 0x0C4
#define DENALI_CTL_50 0x0C8
#define DENALI_CTL_51 0x0CC
#define DENALI_CTL_52 0x0D0
#define DENALI_CTL_53 0x0D4
#define DENALI_CTL_54 0x0D8
#define DENALI_CTL_55 0x0DC
#define DENALI_CTL_56 0x0E0
#define DENALI_CTL_57 0x0E4
#define DENALI_CTL_58 0x0E8
#define DENALI_CTL_59 0x0EC
#define DENALI_CTL_60 0x0F0
#define DENALI_CTL_61 0x0F4
#define DENALI_CTL_62 0x0F8
#define DENALI_CTL_63 0x0FC
#define DENALI_CTL_64 0x100
#define DENALI_CTL_65 0x104
#define DENALI_CTL_66 0x108
#define DENALI_CTL_67 0x10C
#define DENALI_CTL_68 0x110
#define DENALI_CTL_69 0x114
#define DENALI_CTL_70 0x118
#define DENALI_CTL_71 0x11C
#define DENALI_CTL_72 0x120
#define DENALI_CTL_73 0x124
#define DENALI_CTL_74 0x128
#define DENALI_CTL_75 0x12C
#define DENALI_CTL_76 0x130
#define DENALI_CTL_77 0x134
#define DENALI_CTL_78 0x138
#define DENALI_CTL_79 0x13C
#define DENALI_CTL_80 0x140
#define DENALI_CTL_81 0x144

/*Phy is a part of address spase of EMIC*/  
#define DENALI_PHY_BASE  0x1000

#define DENALI_PHY_00  0x000
#define DENALI_PHY_01  0x004
#define DENALI_PHY_02  0x008
#define DENALI_PHY_03  0x00C
#define DENALI_PHY_04  0x010
#define DENALI_PHY_05  0x014
#define DENALI_PHY_06  0x018
#define DENALI_PHY_07  0x01C
#define DENALI_PHY_08  0x020
#define DENALI_PHY_09  0x024
#define DENALI_PHY_10  0x028
#define DENALI_PHY_11  0x02C
#define DENALI_PHY_12  0x030
#define DENALI_PHY_13  0x034
#define DENALI_PHY_14  0x038
#define DENALI_PHY_15  0x03C
#define DENALI_PHY_16  0x040
#define DENALI_PHY_17  0x044
#define DENALI_PHY_18  0x048
#define DENALI_PHY_19  0x04C
#define DENALI_PHY_20  0x050
#define DENALI_PHY_21  0x054
#define DENALI_PHY_22  0x058
#define DENALI_PHY_23  0x05C
#define DENALI_PHY_24  0x060
#define DENALI_PHY_25  0x064
#define DENALI_PHY_26  0x068
#define DENALI_PHY_27  0x06C
#define DENALI_PHY_28  0x070
#define DENALI_PHY_29  0x074
#define DENALI_PHY_30  0x078
#define DENALI_PHY_31  0x07C
#define DENALI_PHY_32  0x080
#define DENALI_PHY_33  0x084
#define DENALI_PHY_34  0x088
#define DENALI_PHY_35  0x08C
#define DENALI_PHY_36  0x090
#define DENALI_PHY_37  0x094
#define DENALI_PHY_38  0x098
#define DENALI_PHY_39  0x09C
#define DENALI_PHY_40  0x0A0
#define DENALI_PHY_41  0x0A4
#define DENALI_PHY_42  0x0A8
#define DENALI_PHY_43  0x0AC
#define DENALI_PHY_44  0x0B0
#define DENALI_PHY_45  0x0B4
#define DENALI_PHY_46  0x0B8
#define DENALI_PHY_47  0x0BC
#define DENALI_PHY_48  0x0C0
#define DENALI_PHY_49  0x0C4
#define DENALI_PHY_50  0x0C8
#define DENALI_PHY_51  0x0CC
#define DENALI_PHY_52  0x0D0
#define DENALI_PHY_53  0x0D4
#define DENALI_PHY_54  0x0D8
#define DENALI_PHY_55  0x0DC
#define DENALI_PHY_56  0x0E0
#define DENALI_PHY_57  0x0E4
#define DENALI_PHY_58  0x0E8
#define DENALI_PHY_59  0x0EC
#define DENALI_PHY_60  0x0F0
#define DENALI_PHY_61  0x0F4
#define DENALI_PHY_62  0x0F8
#define DENALI_PHY_63  0x0FC
#define DENALI_PHY_64  0x100
#define DENALI_PHY_65  0x104
#define DENALI_PHY_66  0x108
#define DENALI_PHY_67  0x10C
#define DENALI_PHY_68  0x110
#define DENALI_PHY_69  0x114
#define DENALI_PHY_70  0x118
#define DENALI_PHY_71  0x11C
#define DENALI_PHY_72  0x120
/*registers 73 - 127 are intentionally blank*/
#define DENALI_PHY_128 0x200
#define DENALI_PHY_129 0x204
#define DENALI_PHY_130 0x208
#define DENALI_PHY_131 0x20C
#define DENALI_PHY_132 0x210
#define DENALI_PHY_133 0x214
#define DENALI_PHY_134 0x218
#define DENALI_PHY_135 0x21C
#define DENALI_PHY_136 0x220
#define DENALI_PHY_137 0x224
#define DENALI_PHY_138 0x228
#define DENALI_PHY_139 0x22C
#define DENALI_PHY_140 0x230
#define DENALI_PHY_141 0x234
#define DENALI_PHY_142 0x238
#define DENALI_PHY_143 0x23C
#define DENALI_PHY_144 0x240
#define DENALI_PHY_145 0x244
#define DENALI_PHY_146 0x248
#define DENALI_PHY_147 0x24C
#define DENALI_PHY_148 0x250
#define DENALI_PHY_149 0x254
#define DENALI_PHY_150 0x258
#define DENALI_PHY_151 0x25C
#define DENALI_PHY_152 0x260
#define DENALI_PHY_153 0x264
#define DENALI_PHY_154 0x268
#define DENALI_PHY_155 0x26C
#define DENALI_PHY_156 0x270
#define DENALI_PHY_157 0x274
#define DENALI_PHY_158 0x278
#define DENALI_PHY_159 0x27C
#define DENALI_PHY_160 0x280
#define DENALI_PHY_161 0x284
#define DENALI_PHY_162 0x288
#define DENALI_PHY_163 0x28C
#define DENALI_PHY_164 0x290
#define DENALI_PHY_165 0x294
#define DENALI_PHY_166 0x298
#define DENALI_PHY_167 0x29C
#define DENALI_PHY_168 0x2A0
#define DENALI_PHY_169 0x2A4
#define DENALI_PHY_170 0x2A8
#define DENALI_PHY_171 0x2AC
#define DENALI_PHY_172 0x2B0
#define DENALI_PHY_173 0x2B4
#define DENALI_PHY_174 0x2B8
#define DENALI_PHY_175 0x2BC
#define DENALI_PHY_176 0x2C0
#define DENALI_PHY_177 0x2C4
#define DENALI_PHY_178 0x2C8
#define DENALI_PHY_179 0x2CC
#define DENALI_PHY_180 0x2D0
#define DENALI_PHY_181 0x2D4
#define DENALI_PHY_182 0x2D8
#define DENALI_PHY_183 0x2DC
#define DENALI_PHY_184 0x2E0
#define DENALI_PHY_185 0x2E4
#define DENALI_PHY_186 0x2E8
#define DENALI_PHY_187 0x2EC
#define DENALI_PHY_188 0x2F0
#define DENALI_PHY_189 0x2F4
#define DENALI_PHY_190 0x2F8
#define DENALI_PHY_191 0x2FC
#define DENALI_PHY_192 0x300
#define DENALI_PHY_193 0x304
#define DENALI_PHY_194 0x308
#define DENALI_PHY_195 0x30C
#define DENALI_PHY_196 0x310
#define DENALI_PHY_197 0x314
#define DENALI_PHY_198 0x318
#define DENALI_PHY_199 0x31C
#define DENALI_PHY_200 0x320
/*registers 201 - 255 are intentionally blank*/
#define DENALI_PHY_256 0x400
#define DENALI_PHY_257 0x404
#define DENALI_PHY_258 0x408
#define DENALI_PHY_259 0x40C
#define DENALI_PHY_260 0x410
#define DENALI_PHY_261 0x414
#define DENALI_PHY_262 0x418
#define DENALI_PHY_263 0x41C
#define DENALI_PHY_264 0x420
#define DENALI_PHY_265 0x424
#define DENALI_PHY_266 0x428
#define DENALI_PHY_267 0x42C
#define DENALI_PHY_268 0x430
#define DENALI_PHY_269 0x434
#define DENALI_PHY_270 0x438
#define DENALI_PHY_271 0x43C
#define DENALI_PHY_272 0x440
#define DENALI_PHY_273 0x444
#define DENALI_PHY_274 0x448
#define DENALI_PHY_275 0x44C
#define DENALI_PHY_276 0x450
#define DENALI_PHY_277 0x454
#define DENALI_PHY_278 0x458
#define DENALI_PHY_279 0x45C
#define DENALI_PHY_280 0x460
#define DENALI_PHY_281 0x464
#define DENALI_PHY_282 0x468
#define DENALI_PHY_283 0x46C
#define DENALI_PHY_284 0x470
#define DENALI_PHY_285 0x474
#define DENALI_PHY_286 0x478
#define DENALI_PHY_287 0x47C
#define DENALI_PHY_288 0x480
#define DENALI_PHY_289 0x484
#define DENALI_PHY_290 0x488
#define DENALI_PHY_291 0x48C
#define DENALI_PHY_292 0x490
#define DENALI_PHY_293 0x494
#define DENALI_PHY_294 0x498
#define DENALI_PHY_295 0x49C
#define DENALI_PHY_296 0x4A0
#define DENALI_PHY_297 0x4A4
#define DENALI_PHY_298 0x4A8
#define DENALI_PHY_299 0x4AC
#define DENALI_PHY_300 0x4B0
#define DENALI_PHY_301 0x4B4
#define DENALI_PHY_302 0x4B8
#define DENALI_PHY_303 0x4BC
#define DENALI_PHY_304 0x4C0
#define DENALI_PHY_305 0x4C4
#define DENALI_PHY_306 0x4C8
#define DENALI_PHY_307 0x4CC
#define DENALI_PHY_308 0x4D0
#define DENALI_PHY_309 0x4D4
#define DENALI_PHY_310 0x4D8
#define DENALI_PHY_311 0x4DC
#define DENALI_PHY_312 0x4E0
#define DENALI_PHY_313 0x4E4
#define DENALI_PHY_314 0x4E8
#define DENALI_PHY_315 0x4EC
#define DENALI_PHY_316 0x4F0
#define DENALI_PHY_317 0x4F4
#define DENALI_PHY_318 0x4F8
#define DENALI_PHY_319 0x4FC
#define DENALI_PHY_320 0x500
#define DENALI_PHY_321 0x504
#define DENALI_PHY_322 0x508
#define DENALI_PHY_323 0x50C
#define DENALI_PHY_324 0x510
#define DENALI_PHY_325 0x514
#define DENALI_PHY_326 0x518
#define DENALI_PHY_327 0x51C
#define DENALI_PHY_328 0x520
/*registers 329 - 383 are intentionally blank*/
#define DENALI_PHY_384 0x600
#define DENALI_PHY_385 0x604
#define DENALI_PHY_386 0x608
#define DENALI_PHY_387 0x60C
#define DENALI_PHY_388 0x610
#define DENALI_PHY_389 0x614
#define DENALI_PHY_390 0x618
#define DENALI_PHY_391 0x61C
#define DENALI_PHY_392 0x620
#define DENALI_PHY_393 0x624
#define DENALI_PHY_394 0x628
#define DENALI_PHY_395 0x62C
#define DENALI_PHY_396 0x630
#define DENALI_PHY_397 0x634
#define DENALI_PHY_398 0x638
#define DENALI_PHY_399 0x63C
#define DENALI_PHY_400 0x640
#define DENALI_PHY_401 0x644
#define DENALI_PHY_402 0x648
#define DENALI_PHY_403 0x64C
#define DENALI_PHY_404 0x650
#define DENALI_PHY_405 0x654
#define DENALI_PHY_406 0x658
#define DENALI_PHY_407 0x65C
#define DENALI_PHY_408 0x660
#define DENALI_PHY_409 0x664
#define DENALI_PHY_410 0x668
#define DENALI_PHY_411 0x66C
#define DENALI_PHY_412 0x670
#define DENALI_PHY_413 0x674
#define DENALI_PHY_414 0x678
#define DENALI_PHY_415 0x67C
#define DENALI_PHY_416 0x680
#define DENALI_PHY_417 0x684
#define DENALI_PHY_418 0x688
#define DENALI_PHY_419 0x68C
#define DENALI_PHY_420 0x690
#define DENALI_PHY_421 0x694
#define DENALI_PHY_422 0x698
#define DENALI_PHY_423 0x69C
#define DENALI_PHY_424 0x6A0
#define DENALI_PHY_425 0x6A4
#define DENALI_PHY_426 0x6A8
#define DENALI_PHY_427 0x6AC
#define DENALI_PHY_428 0x6B0
#define DENALI_PHY_429 0x6B4
#define DENALI_PHY_430 0x6B8
#define DENALI_PHY_431 0x6BC
#define DENALI_PHY_432 0x6C0
#define DENALI_PHY_433 0x6C4
#define DENALI_PHY_434 0x6C8
#define DENALI_PHY_435 0x6CC
#define DENALI_PHY_436 0x6D0
#define DENALI_PHY_437 0x6D4
#define DENALI_PHY_438 0x6D8
#define DENALI_PHY_439 0x6DC
#define DENALI_PHY_440 0x6E0
#define DENALI_PHY_441 0x6E4
#define DENALI_PHY_442 0x6E8
#define DENALI_PHY_443 0x6EC
#define DENALI_PHY_444 0x6F0
#define DENALI_PHY_445 0x6F4
#define DENALI_PHY_446 0x6F8
#define DENALI_PHY_447 0x6FC
#define DENALI_PHY_448 0x700
#define DENALI_PHY_449 0x704
#define DENALI_PHY_450 0x708
#define DENALI_PHY_451 0x70C
#define DENALI_PHY_452 0x710
#define DENALI_PHY_453 0x714
#define DENALI_PHY_454 0x718
#define DENALI_PHY_455 0x71C
#define DENALI_PHY_456 0x720
/*registers 457 - 511 are intentionally blank*/
#define DENALI_PHY_512 0x800
#define DENALI_PHY_513 0x804
#define DENALI_PHY_514 0x808
#define DENALI_PHY_515 0x80C
#define DENALI_PHY_516 0x810
#define DENALI_PHY_517 0x814
#define DENALI_PHY_518 0x818
#define DENALI_PHY_519 0x81C
#define DENALI_PHY_520 0x820
#define DENALI_PHY_521 0x824
#define DENALI_PHY_522 0x828
#define DENALI_PHY_523 0x82C
#define DENALI_PHY_524 0x830
#define DENALI_PHY_525 0x834
#define DENALI_PHY_526 0x838
#define DENALI_PHY_527 0x83C
#define DENALI_PHY_528 0x840
#define DENALI_PHY_529 0x844
#define DENALI_PHY_530 0x848
#define DENALI_PHY_531 0x84C
#define DENALI_PHY_532 0x850
#define DENALI_PHY_533 0x854
#define DENALI_PHY_534 0x858
#define DENALI_PHY_535 0x85C
#define DENALI_PHY_536 0x860
#define DENALI_PHY_537 0x864
#define DENALI_PHY_538 0x868
#define DENALI_PHY_539 0x86C
#define DENALI_PHY_540 0x870
#define DENALI_PHY_541 0x874
#define DENALI_PHY_542 0x878
#define DENALI_PHY_543 0x87C
#define DENALI_PHY_544 0x880
#define DENALI_PHY_545 0x884
#define DENALI_PHY_546 0x888
#define DENALI_PHY_547 0x88C
#define DENALI_PHY_548 0x890
#define DENALI_PHY_549 0x894
#define DENALI_PHY_550 0x898
#define DENALI_PHY_551 0x89C
#define DENALI_PHY_552 0x8A0
#define DENALI_PHY_553 0x8A4
#define DENALI_PHY_554 0x8A8
#define DENALI_PHY_555 0x8AC
#define DENALI_PHY_556 0x8B0
#define DENALI_PHY_557 0x8B4
#define DENALI_PHY_558 0x8B8
#define DENALI_PHY_559 0x8BC
#define DENALI_PHY_560 0x8C0
#define DENALI_PHY_561 0x8C4
#define DENALI_PHY_562 0x8C8
#define DENALI_PHY_563 0x8CC
#define DENALI_PHY_564 0x8D0
#define DENALI_PHY_565 0x8D4
#define DENALI_PHY_566 0x8D8
#define DENALI_PHY_567 0x8DC
#define DENALI_PHY_568 0x8E0
#define DENALI_PHY_569 0x8E4
#define DENALI_PHY_570 0x8E8
#define DENALI_PHY_571 0x8EC
#define DENALI_PHY_572 0x8F0
#define DENALI_PHY_573 0x8F4
#define DENALI_PHY_574 0x8F8
#define DENALI_PHY_575 0x8FC
#define DENALI_PHY_576 0x900
#define DENALI_PHY_577 0x904
#define DENALI_PHY_578 0x908
#define DENALI_PHY_579 0x90C
#define DENALI_PHY_580 0x910

#endif // __DDR_ADDR_H__
