#!/bin/bash -e

rm -f flash_image_array.h
hexdump -v -e '1/4 "%08x"' -e '"\n"' ${1}.bin 1> tmp_image.hex 2>/dev/null

echo "#ifndef __FLASH_IMAGE_ARRAY_H__" > flash_image_array.h
echo "#define __FLASH_IMAGE_ARRAY_H__" >> flash_image_array.h
printf "\n" >> flash_image_array.h
echo "static unsigned int flash_image_array[] __attribute__ ((section (\".image_array\"), aligned (4))) = {" >> flash_image_array.h

sed 's/^/\t0x/;s/$/U,/' tmp_image.hex 2>/dev/null | sed '$ s/.$//' 1>> flash_image_array.h 2>/dev/null
rm -f tmp_image.hex

echo "};" >> flash_image_array.h
printf "\n" >> flash_image_array.h
echo "#endif // __FLASH_IMAGE_ARRAY_H__" >> flash_image_array.h

exit 0
