


typedef struct{

int Port0;
int Port1;
int Port2;
int Port3;
 
} Ports;





// This section contains low-level of abstraction functions that allow read and write each register of the GERA block



void write_PDR0(int a );

int read_PDR0();

void write_DDR0(int a );

int read_DDR0();


void write_EXTIRC_EIENB(int a );


int read_EXTIRC_EIENB();


void write_EXTIRC_EIREQ(int a );

int read_EXTIRC_EIREQ();

void write_EXTIRC_EILVL(int a );

int read_EXTIRC_EILVL();




void write_RA_CONTR(int a);


int read_RA_CONTR();


void write_RA_VAL(int a);


int read_RA_VAL();


void write_REGIME(int a);


int read_REGIME();







///





void GPIO0_1_config(int a , Ports GPIO);

void GPIO2_3_config(int a , Ports GPIO);

void GPIO4_5_config(int a , Ports GPIO);

void GPIO6_7_config(int a , Ports GPIO);



void GPIO0_send(int a , Ports GPIO);

void GPIO1_send(int a , Ports GPIO);

void GPIO2_send(int a , Ports GPIO);

void GPIO3_send(int a , Ports GPIO);

void GPIO4_send(int a , Ports GPIO);

void GPIO5_send(int a , Ports GPIO);

void GPIO6_send(int a , Ports GPIO);

void GPIO7_send(int a , Ports GPIO);


int GPIO0_receive(Ports GPIO);

int GPIO1_receive(Ports GPIO);


void RA0_config(int c, Ports RA );

void RA1_config(int c, Ports RA );

void RA2_config(int c, Ports RA );

void RA3_config(int c, Ports RA );

void RA0_send(Ports RA);

void RA1_send(Ports RA);

void RA2_send(Ports RA);

void RA3_send(Ports RA);


void EXTIRC0_config(int c ,int f, Ports EXTIRC);

void EXTIRC1_config(int c ,int f, Ports EXTIRC);

void EXTIRC2_config(int c ,int f, Ports EXTIRC);

void EXTIRC3_config(int c ,int f, Ports EXTIRC);

void EXTIRC4_config(int c ,int f, Ports EXTIRC);

void EXTIRC5_config(int c ,int f, Ports EXTIRC);

void EXTIRC6_config(int c ,int f, Ports EXTIRC);

void EXTIRC7_config(int c ,int f, Ports EXTIRC);


void GPIO0_int_config(int c ,int f, Ports EXTIRC);

void GPIO1_int_config(int c ,int f, Ports EXTIRC);

void GPIO2_int_config(int c ,int f, Ports EXTIRC);

void GPIO3_int_config(int c ,int f, Ports EXTIRC);

void GPIO4_int_config(int c ,int f, Ports EXTIRC);

void GPIO5_int_config(int c ,int f, Ports EXTIRC);

void GPIO6_int_config(int c ,int f, Ports EXTIRC);

void GPIO7_int_config(int c ,int f, Ports EXTIRC);


void R0_int_config(int c,int f, Ports RA );

void R1_int_config(int c,int f, Ports RA );

void R2_int_config(int c,int f, Ports RA );

void R3_int_config(int c,int f, Ports RA );


void A0_int_config(int c,int f, Ports RA );

void A1_int_config(int c,int f, Ports RA );

void A2_int_config(int c,int f, Ports RA );

void A3_int_config(int c,int f, Ports RA );


void EXTIRC0_clear( Ports EXTIRC) ;

void EXTIRC1_clear( Ports EXTIRC) ;

void EXTIRC2_clear( Ports EXTIRC) ;

void EXTIRC3_clear( Ports EXTIRC) ;

void EXTIRC4_clear( Ports EXTIRC) ;

void EXTIRC5_clear( Ports EXTIRC) ;

void EXTIRC6_clear( Ports EXTIRC) ;

void EXTIRC7_clear( Ports EXTIRC) ;


void GPIO0_int_clear( Ports GPIO);

void GPIO1_int_clear( Ports GPIO);

void GPIO2_int_clear( Ports GPIO);

void GPIO3_int_clear( Ports GPIO);

void GPIO4_int_clear( Ports GPIO);

void GPIO5_int_clear( Ports GPIO);

void GPIO6_int_clear( Ports GPIO);

void GPIO7_int_clear( Ports GPIO);


void R0_int_clear(Ports RA );

void R1_int_clear(Ports RA );

void R2_int_clear(Ports RA );

void R3_int_clear(Ports RA );


void A0_int_clear(Ports RA );

void A1_int_clear(Ports RA );

void A2_int_clear(Ports RA );

void A3_int_clear(Ports RA );


















