//There are subprograms for the protection of memory sections through MPU. 
//protectmem_seg protect only one section which has input addr
//protectmem_all protect only all section : 0000_0000 - 0007_FFFFh
//protectmem_ft_seg protect sections which lie between addr1 and addr2


int protectmem_seg( unsigned int addr, unsigned char rw); // rw: 1 - to protect on read, 2 - to protect on write, 3 - to protect both read and write

int unprotectmem_seg( unsigned int addr, unsigned char rw); // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write

int protectmem_all(unsigned char rw); // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write

int unprotectmem_all(unsigned char rw); // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write

int protectmem_ft_seg( unsigned int addr1, unsigned int addr2, unsigned char rw); // rw: 1 - to protect on read, 2 - to protect on write, 3 - to protect both read and write

int unprotectmem_ft_seg( unsigned int addr1, unsigned int addr2, unsigned char rw); // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write













































