
#ifndef _GIC_H_
#define _GIC_H_

#include "defs.h"

typedef struct{
  u32 SGI_Type;   // Bit Mask, Each Bit: 1 - FIQ, 0 - IRQ
  u64 SPI_Type;   // Bit Mask, Each Bit: 1 - FIQ, 0 - IRQ
  u64 SPI_Enable; // Bit Mask, Each Bit: 1 - Enable, 0 - Disable
} T_gic_configuration;

void gic_config(T_gic_configuration gic_configuration);


#endif
