
#ifndef _HANDLERS_C_H
#define _HANDLERS_C_H
#include "tube_print.h"


// ----------------------------------------------------------------------------------
//  Default interrupt handler
void __attribute__((interrupt("IRQ"))) __attribute__ ((noreturn)) Default_Handler()
{
    tubef_str("Test FAILED: Default_Handler invoked.");
    tubef_die();
    while(1){}
}


//~ void  Reset_Handler()              __attribute__ ((weak, alias("Default_Handler")));  // defined in init.s
void  Undefined_Handler()  __attribute__ ((weak, alias("Default_Handler")));
void  SWI_Handler()        __attribute__ ((weak, alias("Default_Handler")));
void  Prefetch_Handler()   __attribute__ ((weak, alias("Default_Handler")));
void  Abort_Handler()      __attribute__ ((weak, alias("Default_Handler")));
//~ void  IRQ_Handler()        __attribute__ ((weak, alias("Default_Handler")));
void  FIQ_Handler()        __attribute__ ((weak, alias("Default_Handler")));

#endif
