
//~ #include "defs.h"
#include "handlers_c.h"

//-------------------------------------------------------
// ISR_DEFAULT is not an __attribute__((interrupt("IRQ")))
// It is ordinary function
void __attribute__ ((noreturn)) ISR_DEFAULT() 
{
    tubef_str("Test FAILED: ISR_DEFAULT invoked.");
    tubef_die();
    while(1){}
}



void ISR_SWINT0()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT1()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT2()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT3()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT4()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT5()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT6()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SWINT7()  __attribute__ ((weak, alias("ISR_DEFAULT")));


void ISR_COMMRX()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_COMMTX()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CTIRQ()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_TS_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_TIMINT0()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_TIMINT1()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_WDOGINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_WKUPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC0_HPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC1_HPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC2_HPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC3_HPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_ELC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));  // PC's ELC
void ISR_NMPU0_HPINT_ELC_INT0()  __attribute__ ((weak, alias("ISR_DEFAULT"))); // Top's ELCs
void ISR_NMPU1_HPINT_ELC_INT1()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU2_HPINT_ELC_INT2()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU3_HPINT_ELC_INT3()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP0_SRC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP0_DST_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP1_SRC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP1_DST_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP2_SRC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP2_DST_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP3_SRC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_CP3_DST_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_MDMAC_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_MPUW_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_MPUR_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SSPDMA_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT0()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT1()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_EMI_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_SSP_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_ETH_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT2()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT3()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_DMA_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_LCL_INT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_LEG_INTA()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_LEG_INTB()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_LEG_INTC()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PCIE_LEG_INTD()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT4()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT5()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC0_LPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC1_LPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC2_LPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PC3_LPINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU0_LPINT_PLLL0_RDYINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU1_LPINT_PLLL1_RDYINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU2_LPINT_PLLL2_RDYINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_NMPU3_LPINT_PLLL3_RDYINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT6()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_GE_INT7()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_L2C_DECERR()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_L2C_SLVERR()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_L2C_CINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PMUIRQ()  __attribute__ ((weak, alias("ISR_DEFAULT")));
void ISR_PLLX_RDYINT()  __attribute__ ((weak, alias("ISR_DEFAULT")));







// ----------------------------------------------------------------------------------
// Interrupt vector table 
//
// *** Order Correlates With defs.h Defines ***
void (* const InterruptVector[])() = {
  ISR_SWINT0,     // 0-15 SGIs
  ISR_SWINT1,
  ISR_SWINT2,
  ISR_SWINT3,
  ISR_SWINT4,
  ISR_SWINT5,
  ISR_SWINT6,
  ISR_SWINT7,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,    // 16-31 PPIs
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_COMMRX,         // Former - SPIs
  ISR_COMMTX,
  ISR_CTIRQ,
  ISR_TS_INT,
  ISR_TIMINT0,
  ISR_TIMINT1,
  ISR_WDOGINT,
  ISR_WKUPINT,
  ISR_PC0_HPINT,
  ISR_PC1_HPINT,
  ISR_PC2_HPINT,
  ISR_PC3_HPINT,
  ISR_NMPU0_HPINT_ELC_INT0,
  ISR_NMPU1_HPINT_ELC_INT1,
  ISR_NMPU2_HPINT_ELC_INT2,
  ISR_NMPU3_HPINT_ELC_INT3,
  ISR_CP0_SRC_INT,
  ISR_CP0_DST_INT,
  ISR_CP1_SRC_INT,
  ISR_CP1_DST_INT,
  ISR_CP2_SRC_INT,
  ISR_CP2_DST_INT,
  ISR_CP3_SRC_INT,
  ISR_CP3_DST_INT,
  ISR_MDMAC_INT,
  ISR_MPUW_INT,
  ISR_MPUR_INT,
  ISR_SSPDMA_INT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_GE_INT0,
  ISR_GE_INT1,
  ISR_EMI_INT,
  ISR_ELC_INT,
  ISR_SSP_INT,
  ISR_ETH_INT,
  ISR_DEFAULT,
  ISR_DEFAULT,
  ISR_GE_INT2,
  ISR_GE_INT3,
  ISR_PCIE_DMA_INT,
  ISR_PCIE_LCL_INT,
  ISR_PCIE_LEG_INTA,
  ISR_PCIE_LEG_INTB,
  ISR_PCIE_LEG_INTC,
  ISR_PCIE_LEG_INTD,
  ISR_GE_INT4,
  ISR_GE_INT5,
  ISR_PC0_LPINT,
  ISR_PC1_LPINT,
  ISR_PC2_LPINT,
  ISR_PC3_LPINT,
  ISR_NMPU0_LPINT_PLLL0_RDYINT,  // NMPU0_LPINT for PC and PLLL0_RDYINT for CCPU
  ISR_NMPU1_LPINT_PLLL1_RDYINT,  // NMPU1_LPINT for PC and PLLL1_RDYINT for CCPU
  ISR_NMPU2_LPINT_PLLL2_RDYINT,  // NMPU2_LPINT for PC and PLLL2_RDYINT for CCPU
  ISR_NMPU3_LPINT_PLLL3_RDYINT,  // NMPU3_LPINT for PC and PLLL3_RDYINT for CCPU
  ISR_GE_INT6,
  ISR_GE_INT7,
  ISR_L2C_DECERR,
  ISR_L2C_SLVERR,
  ISR_L2C_CINT,
  ISR_PMUIRQ,
  ISR_PLLX_RDYINT,  // PLLH_RDYINT for PC and PLLC_RDYINT for CCPU
  ISR_DEFAULT
};

/*
// Moved To Assembler
void __attribute__((interrupt("IRQ"))) IRQ_Handler_Wrapper()
{
  int interrupt_ID = rgGICC_IAR;              // What Peripherial Makes Interrupt Request
  
  asm("  LDR R0, =%0\n"
      "  LDR R1, =%1\n"
      "  ADD R0, R0, R1, LSL #3\n"
      "  LDR R1, [R0]"
      "  BLX R1\n"
      "  NOP\n"::"r" (InterruptVector) , "r" (interrupt_ID) : "r0", "r1");
  
  rgGICC_EOIR = interrupt_ID;                 // End-Of-Interrupt Register
}
*/

