
#include "defs_s.h"
#include "macro.incl"
    
    .global  tubef_die
    .global  tubef_dec
    .global  tubef_hex
    .global  tubef_str
    
tubef_die: @-----------------------------
    tube_die "CALL tube_die_func()"
    BX  LR@ return

tubef_dec: @-----------------------------
    tube_dec R0
    BX LR@ return
    
tubef_hex: @-----------------------------
    tube_hex R0
    BX LR@ return
       
tubef_str: @-----------------------------
@
@ R0 - char * (0-terminated string; must be aligned 4)   
@
    PUSH {R0-R5, LR}
    
    LDR  R1, =TUBE_Base
    
m11:
    LDR R4, [R0], #4
    REV R4, R4
    
    MOV R3, #0
    LSR R2, R4, #24
    ANDS R2, R2, #0xff 
    BEQ print_last_word_2
    @tube_hex R2
    ADD R3, R3, #1
    LSR R2, R4, #16
    ANDS R2, R2, #0xff 
    BEQ print_last_word_2
    @tube_hex R2
    ADD R3, R3, #1
    LSR R2, R4, #8
    ANDS R2, R2, #0xff 
    BEQ print_last_word_2
    @tube_hex R2
    ADD R3, R3, #1
    ANDS R2, R4, #0xff 
    BEQ print_last_word_2
    @tube_hex R2
    
    STR  R4, [R1, #TUBE_PRINTSTR]
    B m11
    
print_last_word_2: 
    @tube_dec R3   
    LDR R4, =0x0d0d0d0d
    SUB R0, R0, #4
m22:
    SUBS R3, R3, #1
    BLT  m33
    LDRB R2, [R0, R3]
    LSL R4, R4, #8
    ORR R4, R4, R2
    B  m22
    
m33:
    REV R4, R4
    STR R4, [R1, #TUBE_PRINTSTR]
    POP {R0-R5, LR}
    BX  LR@ return
    
