@echo off

if %1 == mc12705 (
    set DEF_FLAG=-DMC12705
	set DEV_NAME=mc12705
	set LIB_NAME=mc12705load
) else   if %1 == nm_card (
       set DEF_FLAG=-DNM_CARD
	    set DEV_NAME=nm_card
	    set LIB_NAME=nm_card_load
 ) else   if %1 == nm_mezzo (
       set DEF_FLAG=-DNM_MEZZO
	    set DEV_NAME=nm_mezzo
	    set LIB_NAME=nm_mezzo_load
) else   if %1 == nm_quad (
       set DEF_FLAG=-DNM_QUAD
	    set DEV_NAME=nm_quad
	    set LIB_NAME=nm_quad_load
)
set INC_PATH=..\include
set LIBIOS_PATH=..\lib

set LLC_INC_PATH= %INC_PATH%\%DEV_NAME%
set LLC_PATH=%LIBIOS_PATH%\%DEV_NAME%
set BIN_PATH=..\bin_%DEV_NAME%

echo ======= HOST Compiler
setlocal
@call "%VS140COMNTOOLS%..\..\vc\vcvarsall.bat" amd64

set TC=tc_printf

echo on
@for  %%g in (%TC%) do (
 cl %%g.cpp %DEF_FLAG% -W3 -MT -EHsc -I. -I%INC_PATH% -I%LLC_INC_PATH% -link -LIBPATH:%LLC_PATH%  %LIB_NAME%.lib -LIBPATH:%LIBIOS_PATH% io_host.lib   -out:%BIN_PATH%\%%g.exe
)
@copy %LLC_PATH%\%LIB_NAME%.dll %BIN_PATH%\.

endlocal
:END


