#!/bin/bash

if [ "$1" != "mc12705" ] && [ "$1" != "nm_card" ] && [ "$1" != "nm_mezzo" ] && [ "$1" != "nm_quad" ] && [ "$1" != "neuro_mezzanine" ]; then
	echo "ERROR: Unknown board!"
	exit -1
fi

RES=0
./tc_stdio.out  ${1} -1 1  > run_out
ls -l | grep "run_out" || RES=1
grep "ERROR" run_out && RES=1
grep "FAIL" run_out && RES=1
grep "PASS" run_out || RES=1

if [ $RES -eq 0 ]; then
	echo "TEST ***** PASS ******"
else
    echo "TEST *****FAIL ******"
fi




