#!/bin/bash -e

 if [ "$1" != "mc12705" ] && [ "$1" != "nm_card" ] && [ "$1" != "nm_mezzo" ] && [ "$1" != "nm_quad" ] && [ "$1" != "neuro_mezzanine" ]; then
	echo "ERROR: Unknown board!"
	exit -1
fi
T_BIN=bin_trg
H_BIN=bin_$1
mkdir -p $T_BIN
mkdir -p $H_BIN
mkdir -p target/MAP_DMA

make -C host $1

make -C target -f Makefile_nmc clean
make -C target -f Makefile_nmc

make -C target -f Makefile_arm clean
make -C target -f Makefile_arm

cp run* $H_BIN/.
cp loop_run* $H_BIN/.


