/*
   trg_stdio test 
		void clearerr( FILE *stream);
		int feof( FILE *stream);
		int ferror( FILE *stream);
		int fileno( FILE *stream); 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int res=345;
	int f_nmb=-1;
	int f_fd, errno1;
	char * f_name = "F_0";
	char * tmp_f_name = "TMP_FILE_t18";
	int flag_d = O_CREAT|O_TRUNC|O_RDWR;
	FILE *fd = NULL;
	char mode[8];
	char arr_in[32], arr_out[32];
	fpos_t pos;
	
	strcpy(mode,"w+");

	trg_hostSync(0x10);
	printf("%s STDIO open %s START\n",CORE_TYPE,tmp_f_name);
	if((f_nmb=open(tmp_f_name, flag_d)) < 0){
		printf("%s STDIO open  ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open  PASS\n",CORE_TYPE);
	}
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode);
	if((fd=fopen(f_name,mode)) == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d FAIL \n",CORE_TYPE,
					mode,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO --TESTING-- FILENO\n",CORE_TYPE);
	if((f_fd=fileno(fd)) != (f_nmb+1)){
		printf("%s STDIO FILENO f_fd=%d expect %d FAIL\n",CORE_TYPE,f_fd,(f_nmb+1));
		FAIL=1;
	}else{
		printf("%s STDIO FILENO  f_fd=%d expect %d  PASS\n",CORE_TYPE,f_fd,(f_nmb+1));
	}
	printf("%s STDIO FWRITE START\n",CORE_TYPE);
	strcpy(arr_out,"1234567890123456");
	res=9999999;
	if((res=fwrite(arr_out,1,9,fd)) != 9){
		printf("%s STDIO FWRITE ERROR res=%d errno=%d FAIL\n",CORE_TYPE,res,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FWRITE PASS res=%d errno=%d\n",CORE_TYPE,res,errno);
	}
	
	printf("%s STDIO  SET FEOF by fread(...)\n",CORE_TYPE);
	fread(arr_in,1,10,fd);
	printf("%s STDIO --TESTING-- FEOF\n",CORE_TYPE);
	printf("%s STDIO FEOF  on eof START pos=%ld\n",CORE_TYPE,ftell(fd));
	if((res=feof(fd)) == 0){
		printf("%s STDIO FEOF ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno);
		FAIL=1;
	}else 
		printf("%s STDIO FEOF on eof res= %d PASS\n",CORE_TYPE,res);

	printf("%s STDIO FSEEK INTO file\n",CORE_TYPE);
	if((res=fseek(fd,5,SEEK_SET)) != 0){
		printf("%s STDIO fseek(fd) ERROR  res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FEOF  into file START pos=%ld\n",CORE_TYPE,ftell(fd));
	if((res=feof(fd)) != 0){
		printf("%s STDIO FEOF ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FEOF into file res= %d PASS\n",CORE_TYPE,res);
	}
	printf("%s STDIO  SET FEOF by fread(...)\n",CORE_TYPE);
	fread(arr_in,1,10,fd);

	if((res=feof(fd)) == 0){
		printf("%s STDIO FEOF ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FEOF on eof res= %d PASS\n",CORE_TYPE,res);
	}
	printf("%s STDIO --TESTING-- CLEARERR with FEOF\n",CORE_TYPE);
	printf("%s STDIO  SET FEOF by fread(...)\n",CORE_TYPE);
	fread(arr_in,1,9,fd);
	printf("%s STDIO CLEARERR  TO END+1 START pos=%ld\n",CORE_TYPE,ftell(fd));
	clearerr(fd);
	printf("%s STDIO FEOF  after  CLEARERR START pos=%ld\n",CORE_TYPE,ftell(fd));
	if((res=feof(fd)) != 0){
		printf("%s STDIO FEOF ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FEOF after  CLEARERR res= %d PASS\n",CORE_TYPE,res);
	}
	printf("%s STDIO --TESTING-- FERROR\n",CORE_TYPE);
	printf("%s STDIO close(f_fd=%d) & close(f_nmb=%d) START\n",CORE_TYPE,f_fd,f_nmb);
	errno=0;
	if((res=close(f_fd)) != 0){
		printf("%s STDIO close(f_fd) ERROR errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(f_fd) PASS  \n",CORE_TYPE);
	}
	close(f_nmb);
	unlink(tmp_f_name);
	printf("%s STDIO  SET error by write(...)\n",CORE_TYPE);
	errno=0;
	res=fwrite(arr_out,1,9,fd);
	errno1 = errno;
	printf("%s STDIO fwrite expect error res=%d errno=%d \n",CORE_TYPE,res,errno1);
	errno=0;
	res=fflush(fd);
	printf("%s STDIO fflush(fd) expect error res=%d errno=%d \n",CORE_TYPE,res,errno);
	printf("%s STDIO FERROR  START pos=%ld\n",CORE_TYPE,ftell(fd));
	if((res=ferror(fd)) == 0){
		printf("%s STDIO FERROR ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno1);
		FAIL=1;
	}else{
		printf("%s STDIO FERROR after  write error res= %d PASS\n",CORE_TYPE,res);
	}
	trg_hostSync(0x30);
	printf("%s STDIO SECOND FERROR  START \n",CORE_TYPE);
	if((res=ferror(fd)) == 0){
		printf("%s STDIO FERROR ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno1);
		FAIL=1;
	}else{
		printf("%s STDIO FERROR PASS  res= %d \n",CORE_TYPE,res);
	}
	printf("%s STDIO --TESTING-- CLEARERR with ferror >0\n",CORE_TYPE);
	clearerr(fd);
	printf("%s STDIO FERROR  AFTER CLEARERR START \n",CORE_TYPE);
	if((res=ferror(fd)) != 0){
		printf("%s STDIO FERROR ERROR res=%d errno=%d FAIL\n",CORE_TYPE,
				res,errno1);
		FAIL=1;
	}else{
		printf("%s STDIO FERROR PASS  res= %d \n",CORE_TYPE,res);
	}
	trg_hostSync(0x40);
	printf("%s STDIO fclose(fd) START\n",CORE_TYPE);
	if((res=fclose(fd)) != 0){
		printf("%s STDIO fclose(fd) PASS errno=%d \n",CORE_TYPE,errno);
	}else{
		printf("%s STDIO fclose(fd) ERROR  \n",CORE_TYPE);
		FAIL=1;
	}

	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
