/*
   trg_stdio printf, sprintf, fprintf
   Texty stream
*/

#include <stddef.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int res;
	char *F1 = "F_WITH_MODE";
	FILE *fd = NULL;
	FILE *fr = NULL;
	char out[64];
	char arr[64];
	char *mode[]= {"w+","w+b"};
	char *rmode[]= {"r","rb"};

	trg_hostSync(0x10);

	printf("%s STDIO TEST FPRINTF\n",CORE_TYPE);
	if((fd=fopen("F_0",rmode[0])) == NULL){
		printf("%s STDIO fopen ERROR mode%s  errno=%d \n",CORE_TYPE,rmode[0],errno);
		return -1;
	}
	printf("%s STDIO fopen F_0 OK mode%s\n",CORE_TYPE,rmode[0]);
//	fprintf(fd,"%s FPRINTF *********  %s\n",CORE_TYPE,"FPRINTF");
//	fflush(fd);
//	rewind(fd);

	memset(out,0,64);
	if((res=fread(out,1,64,fd)) <= 0){
		printf("%s STDIO fread ERROR res=%d  errno=%d \n",CORE_TYPE,res,errno);
		return -1;
	}
	//////////////////////////////////////////////////

	//////////////////////////////////
	fclose(fd);
	printf("FREAD %s\n",out);
/*	//////////////////////////////////////////////////
	printf("%s STDIO  PUTCHAR START\n",CORE_TYPE);
	for(int k=0; k<res; k++){
		putchar(out[k]);
	}
	printf("%s STDIO  PUTCHAR END\n",CORE_TYPE);
	*//////////////////////////////////
	trg_hostSync(0x20);
	
	trg_hostSync(0x30);

	trg_hostSync( 0x40);
	trg_hostSync(0x50);

    return 0;
}
