/*
     trg_stdio test putchar, puts
		int putchar(int c);
		int puts(const char *s);
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	char arr_in[32], arr_out[32];
/*
int putchar(int c);
int puts(const char *s);
*/
	trg_hostSync(0x10);
	
	printf("%s STDIO putchar START r=0x%x  EOF=0x%x \n",CORE_TYPE,'r',EOF);
	st=putchar('r');
	if(st != 'r'){
		printf("%s STDIO putchar ERROR  st=0x%x errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO putchar st=%c PASS \n",CORE_TYPE,st);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO puts START \n",CORE_TYPE);
	st=puts("***puts***");
	if(st == EOF){
		printf("%s STDIO puts ERROR  st=0x%x errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO puts st=%d PASS \n",CORE_TYPE,st);
	}
	
	trg_hostSync(0x30);
	trg_hostSync(0x40);
	trg_hostSync(0x50);
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
