/*
     trg_stdio test 		
		int getchar(void);
		char *gets(char *s);
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	char *buf;
	char arr_in[32], arr_out[32];
	int t=0xFFFFFF;
	
/*
int getchar(void);
char *gets(char *s);
*/
	trg_hostSync(0x1F);
	
	printf("%s STDIO getchar START t=0x%x\n",CORE_TYPE,t);
	puts("***** GETCHAR>");
	trg_hostSync( 0x20);
	st=getchar();
	if(st <0){
		printf("%s STDIO getchar ERROR  st=0x%x errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO getchar st=%c PASS \n",CORE_TYPE,st);
	}

	puts("START fflush(stdin)");
	fflush(stdin);
	puts("***** GETCHAR 2 Not answer");
	trg_hostSync(0x30);
	st=getchar();
	printf("%s STDIO getchar st=%c  \n",CORE_TYPE,st);
	
	printf("%s STDIO gets START \n",CORE_TYPE);
	puts("***** GETS >");
	trg_hostSync(0x40);
	buf=gets(arr_in);
	if(buf == NULL){
		printf("%s STDIO gets ERROR  buf=0x%x errno=%d \n",CORE_TYPE,buf,errno);
		FAIL=1;
	}else{
		printf("%s STDIO gets PASS arr_in=%s    buf=%s  \n",CORE_TYPE,arr_in,buf);
		printf("%s STDIO gets PASS arr_in=%p buf=%p \n",CORE_TYPE,arr_in,buf);
	}
	
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
