#define SSP_Base  0x000CF000
#define SSP_CR0   0x000
#define SSP_CR1   0x004
#define SSP_DR    0x008
#define SSP_SR    0x00C
#define SSP_CPSR  0x010

.global SIMPLE_INIT
SIMPLE_INIT: /*-----------------------------------------*/
    
    PUSH {R3-R4, LR}

    LDR  R3, =SSP_Base

    MOV  R4, #0x00 /* SSP disable */
    STR  R4, [R3, #SSP_CR1]
    MOV  R4, #0x09c7  /* 8 bit data */
    STR  R4, [R3, #SSP_CR0]
    MOV  R4, #0x14   /* Clock prescale(CPSR) 200 => ~1 MHz */
    STR  R4, [R3, #SSP_CPSR]
    MOV  R4, #0x0A /* SSP enable */
    STR  R4, [R3, #SSP_CR1]
  
    POP {R3-R4, PC}

