
.global Abort_Handler_Wrapper

.code 32
.section .text

Abort_Handler_Wrapper:
  PUSH {R0-R3}
  
  /*  Determine if its Asyncronous Or Synchronous Abort */
  MRC p15, 0, R0, c5, c0, 0
    /* WnR And Status Fields */
  MOVW R1, #0x080F
  MOVT R1, #0
  AND R0, R0, R1
  MOVW R1, #0x0806 /* async external abort */
  CMP R0, R1
  BNE 11f
  /* in Case Of Asynchronous Abort We Need To Execute That Instruction On Which The Abort Occures */
  /*  So, We Need To Decrement LR */
  SUB LR, LR, #4
  
11:
  PUSH {LR}
  BLX Abort_Handler
  POP {LR}
  POP {R0-R3}
  
    /* Return From Abort, Mode Change Made Automatically */
  SUBS    PC, LR, #4
  NOP
