

typedef struct{
	int numb;
	u32 TR_MainCounter;
	u64 *TR_Address;
	u32 TR_Bias;
	u32 TR_RowCounter;
	u32 TR_AddressMode;
	u32 TR_Control;
	u32 TR_InterruptMask;
	u32 TR_State;
	
	u32 RC_MainCounter;
    u64 *RC_Address;
    u32 RC_Bias;
    u32 RC_RowCounter;
    u32 RC_AddressMode;
	u32 RC_Control;
    u32 RC_InterruptMask;
	u32 RC_State;
} CP_reg_config;


void config_CP(CP_reg_config *reg_config);

void write_start_CP(CP_reg_config *reg_config);

void read_start_CP(CP_reg_config *reg_config);

void read_status_CP(CP_reg_config *reg_config);

int read_RC_ctrl_CP(int numb);

int read_TR_ctrl_CP(int numb);
