
#include "defs.h"

 void ConfigMDMAC ( void* SrcAddress, void* DstAddress, u32 SrcRowCounter , u32 DstRowCounter , u32 SrcBias , u32 DstBias , u32 SrcAddressMode , u32 DstAddressMode )
{
    rgMDMAC_SrcAddress     = (u32) SrcAddress;
    rgMDMAC_DstAddress     = (u32) DstAddress;
    
    rgMDMAC_SrcBias        = SrcBias*8; // 64b words
    rgMDMAC_DstBias        = DstBias*8; // 64b words
    
    rgMDMAC_SrcRowCounter  = SrcRowCounter;
    rgMDMAC_DstRowCounter  = DstRowCounter;
    
    rgMDMAC_SrcAddressMode = SrcAddressMode;
    rgMDMAC_DstAddressMode = DstAddressMode;
    
};

 void SetMainCounterMDMAC(u32 count)
{
    rgMDMAC_MainCounter = count;
};

 void StartMDMAC()
{
    rgMDMAC_Control = 0x01;
};

 void ConfirmEndMDMAC()
{
    while(!(rgMDMAC_Control&0x2)) 
    {
      // Error Return ???
    }
    rgMDMAC_Control = 0x00;
};

int StatusTransMDMAC()
{
    int stat;
    stat = (rgMDMAC_Control&0x2)>>1;
    return stat;
};
