#!/bin/bash +e





CUR_DIR=`pwd`
#echo "CUR_DIR = $CUR_DIR , 0 = $0 1 = $1 "
echo "CUR_DIR = $CUR_DIR , 0 = $0 "
BSP_DIR=`dirname $(readlink -f $0)`
#MAJOR=2
#MINOR=1
# edit?
#if [[ "$1" != "mc12705" ]] && [[ "$1" != "nm_card" ]] && [[ "$1" != "nm_mezzo" ]]; then
##################
DIALOG=${DIALOG=dialog}
tempfile=`mktemp 2>/dev/null` || tempfile=/tmp/test$$
trap "rm -f $tempfile" 0 1 2 5 15

$DIALOG --clear --title "Neuromatrix software install" \
        --menu "Choose package:" 20 51 4 \
        "nm_card" "" \
        "nm_mezzo" "" \
        "nm_quad" "" 2> $tempfile

retval=$?
echo $retval
BOARD_NAME=`cat $tempfile`
echo $BOARD_NAME 
#case $retval in
#  0)
#    echo " '$BOARD_NAME ' -- selected!";;
#  1)
#    echo "Cancelled";;
#    #exit  
#    #echo "-1"
#  255)
#    echo "ESC print.";;
#esac
if [ $retval -eq 1 ] 
	then
	echo "Cancelled"
	exit	
fi

case $BOARD_NAME in
	
	nm_card)
		echo "BSP_DIR = $BSP_DIR"

				echo $BOARD_NAME
				
				cd "$BSP_DIR"
				#read -p "Press any key to resume ..."
				
				#(/usr/sbin/dkms status | grep -i ${1} 1>/dev/null 2>&1) || (./driver/dkms.sh install ${1})
				#(/sbin/lsmod | grep -i ${1} 1>/dev/null 2>&1) || (/sbin/modprobe ${1})
				#pushd libload/${1}
				#make install
				#echo "*********make finish***********"
                cp $BSP_DIR/board-nm_card/VERSION.txt $BSP_DIR/ 
				ls
                make -f Makefile-nm_card driver_host lib_host io_host host_run
				echo "***** driver install *****"
				cd $BSP_DIR/driver
				./dkms.sh install nm_card
				cd ..
				#ls -l
				
				#lsmod | grep -i nm_card
				#popd
				udevadm control --reload-rules && udevadm trigger

				echo "***** driver install finished *****"
				echo "***** build_host *****"
				#cd $BSP_DIR/io_service/host
				#make clean
				#make libio_host.a
				#cp libio_host.a ../../board-nm_card/lib
				#ls -l ./build_host/
				#cd $BSP_DIR
				echo "***** host build finish *****"
				#ls -l
				
				#ls
				#mkdir -p "/usr/local/rc_module/board-${1}"
				#cp -ar *"./board-${1}" "/usr/local/rc_module"
				echo "**** build_nm_card_run *****"
				#make -C ./io_service/host all
				#make -C ./run/make nm_card
				echo "***** build_nm_card_run end *****"
				
				echo "***** copy files and links *****"
				echo $(pwd)
				echo $BSP_DIR
				cp -f $BSP_DIR/run/make/nm_card_run $BSP_DIR/board-nm_card/bin/
				cp -f $BSP_DIR/firmware/rom_image/nm_card-firmware.bin $BSP_DIR/board-nm_card/bin/nm_card_firmware.bin
				cp -f $BSP_DIR/firmware/nm_card-init.bin $BSP_DIR/board-nm_card/bin/nm_card_init.bin
				cp -f $BSP_DIR/firmware/nm6408-init.bin $BSP_DIR/board-nm_card/bin/nm6408init.bin
				
				cp -v $BSP_DIR/io_service/host/libio_host.a $BSP_DIR/board-nm_card/lib
				cp -v $BSP_DIR/io_service/include/io_host.h $BSP_DIR/board-nm_card/include/
				cp -v $BSP_DIR/io_service/target/libarm_io.a $BSP_DIR/board-nm_card/lib
				cp -v $BSP_DIR/io_service/target/arm_printf.h $BSP_DIR/board-nm_card/include/
				cp -v $BSP_DIR/io_service/target/libnmc_io.a $BSP_DIR/board-nm_card/lib
				cp -v $BSP_DIR/io_service/target/nmc_printf.h $BSP_DIR/board-nm_card/include/
				
				cp -v $BSP_DIR/libload/nm_card/libnm_card_load.so.2.1 $BSP_DIR/board-nm_card/lib/
				ln -s -f ./libnm_card_load.so.2.1 $BSP_DIR/board-nm_card/lib/libnm_card_load.so.2
				ln -s -f ../lib/libnm_card_load.so.2 $BSP_DIR/board-nm_card/bin/libnm_card_load.so.2
				ln -s -f ./libnm_card_load.so.2.1 $BSP_DIR/board-nm_card/lib/libnm_card_load.so
				ln -s -f ../lib/libnm_card_load.so $BSP_DIR/board-nm_card/bin/libnm_card_load.so
				cp -v $BSP_DIR/libload/nm_card/nm_card_load.h $BSP_DIR/board-nm_card/include/
				cp -v $BSP_DIR/libload/arm/libnm6408load_arm.a $BSP_DIR/board-nm_card/lib/
				ln -s -f ./libnm6408load_arm.a $BSP_DIR/board-nm_card/lib/libnm_card_load_arm.a
				cp -v $BSP_DIR/libload/arm/nm6408load_arm.h $BSP_DIR/board-nm_card/include/
				ln -s -f ./nm6408load_arm.h $BSP_DIR/board-nm_card/include/nm_card_load_arm.h
				cp -v $BSP_DIR/libload/arm/arm_template.x $BSP_DIR/board-nm_card/
				cp -v $BSP_DIR/libload/nmc/libnm6408load_nmc.a $BSP_DIR/board-nm_card/lib/
				ln -s -f ./libnm6408load_nmc.a $BSP_DIR/board-nm_card/lib/libnm_card_load_nmc.a
				cp -v $BSP_DIR/libload/nmc/nm6408load_nmc.h $BSP_DIR/board-nm_card/include/
				ln -s -f ./nm6408load_nmc.h $BSP_DIR/board-nm_card/include/nm_card_load_nmc.h
				cp -v $BSP_DIR/libload/nmc/nmc_template.x $BSP_DIR/board-nm_card/
				
				cp -vf $BSP_DIR/nm_card-2.1.sh /etc/profile.d
				#/usr/bin
				#Add to PATH
				#cp -vf $BSP_DIR/run/make/nm_card_run /usr/bin/
				#cp -vf $BSP_DIR/run/make/nm_card_run /bin/ #f?
				#/usr/include
				cp -vf $BSP_DIR/libload/nm_card/nm_card_load.h /usr/include/
				#/usr/lib
				cp -vf $BSP_DIR/libload/nm_card/libnm_card_load.so.2.1 /usr/lib/
				ln -s -f ./libnm_card_load.so.2.1 /usr/lib/libnm_card_load.so.2
				#ln -s -f ../lib/libnm_card_load.so.2 $BSP_DIR/board-nm_card/bin/libnm_card_load.so.2
				ln -s -f ./libnm_card_load.so.2.1 /usr/lib/libnm_card_load.so
				#ln -s -f ../lib/libnm_card_load.so $BSP_DIR/board-nm_card/bin/libnm_card_load.so
				
				#udevadm control --reload-rules && udevadm trigger
				ldconfig 
				ldconfig -p | grep -i $1
				echo "***** copy files and links end *****"

				;;
	nm_mezzo)
			echo "BSP_DIR = $BSP_DIR"

				echo $BOARD_NAME
				
				cd "$BSP_DIR"
				#read -p "Press any key to resume ..."
				
				#(/usr/sbin/dkms status | grep -i ${1} 1>/dev/null 2>&1) || (./driver/dkms.sh install ${1})
				#(/sbin/lsmod | grep -i ${1} 1>/dev/null 2>&1) || (/sbin/modprobe ${1})
				#pushd libload/${1}
				#make install
				#echo "*********make finish***********"
				cp $BSP_DIR/board-nm_mezzo/VERSION.txt $BSP_DIR/ 
				make -f Makefile-nm_mezzo driver_host lib_host io_host host_run
				echo "***** driver install *****"
				cd $BSP_DIR/driver
				./dkms.sh install nm_mezzo
				cd ..
				#ls -l

				udevadm control --reload-rules && udevadm trigger
				echo "***** driver install finished *****"
				echo "***** build_host *****"
				#read -p "Press any key to resume ..."
				#cd $BSP_DIR/io_service/host
				#make clean
				#make libio_host.a
				#cp libio_host.a ../../board-nm_mezzo/lib
				##ls -l ./build_host/
				#cd $BSP_DIR
				echo "***** host build finish *****"
				##ls -l
				#
				##ls
				##mkdir -p "/usr/local/rc_module/board-${1}"
				##cp -ar "./board-${1}" "/usr/local/rc_module"
				echo "***** build_nm_mezzo_run *****"
				##read -p "Press any key to resume ..."
				#make -C ./io_service/host all
				#make -C ./run/make nm_mezzo
				##read -p "Press any key to resume ..."
				echo "***** build_nm_mezzo_run end *****"
				#
				#echo "***** copy files and links *****"
				echo $(pwd)
				echo $BSP_DIR
				cp -f $BSP_DIR/run/make/nm_mezzo_run $BSP_DIR/board-nm_mezzo/bin/
				cp -f $BSP_DIR/firmware/rom_image/nm_mezzo-firmware.bin $BSP_DIR/board-nm_mezzo/bin/nm_mezzo_firmware.bin
				cp -f $BSP_DIR/firmware/nm_mezzo-init.bin $BSP_DIR/board-nm_mezzo/bin/nm_mezzo_init.bin
				cp -f $BSP_DIR/firmware/nm6408-init.bin $BSP_DIR/board-nm_mezzo/bin/nm6408init.bin
				
				cp -v $BSP_DIR/io_service/host/libio_host.a $BSP_DIR/board-nm_mezzo/lib
				cp -v $BSP_DIR/io_service/include/io_host.h $BSP_DIR/board-nm_mezzo/include/
				cp -v $BSP_DIR/io_service/target/libarm_io.a $BSP_DIR/board-nm_mezzo/lib
				cp -v $BSP_DIR/io_service/target/arm_printf.h $BSP_DIR/board-nm_mezzo/include/
				cp -v $BSP_DIR/io_service/target/libnmc_io.a $BSP_DIR/board-nm_mezzo/lib
				cp -v $BSP_DIR/io_service/target/nmc_printf.h $BSP_DIR/board-nm_mezzo/include/
				
				cp -v $BSP_DIR/libload/nm_mezzo/libnm_mezzo_load.so.2.0 $BSP_DIR/board-nm_mezzo/lib/
				ln -s -f ./libnm_mezzo_load.so.2.1 $BSP_DIR/board-nm_mezzo/lib/libnm_mezzo_load.so.2
				ln -s -f ../lib/libnm_mezzo_load.so.2 $BSP_DIR/board-nm_mezzo/bin/libnm_mezzo_load.so.2
				ln -s -f ./libnm_mezzo_load.so.2.1 $BSP_DIR/board-nm_mezzo/lib/libnm_mezzo_load.so
				ln -s -f ../lib/libnm_mezzo_load.so $BSP_DIR/board-nm_mezzo/bin/libnm_mezzo_load.so
				cp -v $BSP_DIR/libload/nm_mezzo/nm_mezzo_load.h $BSP_DIR/board-nm_mezzo/include/
				cp -v $BSP_DIR/libload/arm/libnm6408load_arm.a $BSP_DIR/board-nm_mezzo/lib/
				ln -s -f ./libnm6408load_arm.a $BSP_DIR/board-nm_mezzo/lib/libnm_mezzo_load_arm.a
				cp -v $BSP_DIR/libload/arm/nm6408load_arm.h $BSP_DIR/board-nm_mezzo/include/
				ln -s -f ./nm6408load_arm.h $BSP_DIR/board-nm_mezzo/include/nm_mezzo_load_arm.h
				cp -v $BSP_DIR/libload/arm/arm_template.x $BSP_DIR/board-nm_mezzo/
				cp -v $BSP_DIR/libload/nmc/libnm6408load_nmc.a $BSP_DIR/board-nm_mezzo/lib/
				ln -s -f ./libnm6408load_nmc.a $BSP_DIR/board-nm_mezzo/lib/libnm_mezzo_load_nmc.a
				cp -v $BSP_DIR/libload/nmc/nm6408load_nmc.h $BSP_DIR/board-nm_mezzo/include/
				ln -s -f ./nm6408load_nmc.h $BSP_DIR/board-nm_mezzo/include/nm_mezzo_load_nmc.h
				cp -v $BSP_DIR/libload/nmc/nmc_template.x $BSP_DIR/board-nm_mezzo/
				
				cp -vf $BSP_DIR/nm_mezzo-2.1.sh /etc/profile.d
				#/usr/bin
				#Add to PATH
				#cp -vf $BSP_DIR/run/make/nm_card_run /usr/bin/
				#cp -vf $BSP_DIR/run/make/nm_card_run /bin/ #f?
				#/usr/include
				cp -vf $BSP_DIR/libload/nm_mezzo/nm_mezzo_load.h /usr/include/
				#/usr/lib
				cp -vf $BSP_DIR/libload/nm_mezzo/libnm_mezzo_load.so.2.1 /usr/lib/
				ln -s -f ./libnm_mezzo_load.so.2.1 /usr/lib/libnm_mezzo_load.so.2
				#ln -s -f ../lib/libnm_card_load.so.2 $BSP_DIR/board-nm_card/bin/libnm_card_load.so.2
				ln -s -f ./libnm_mezzo_load.so.2.1 /usr/lib/libnm_mezzo_load.so
				#ln -s -f ../lib/libnm_card_load.so $BSP_DIR/board-nm_card/bin/libnm_card_load.so
				
				#udevadm control --reload-rules && udevadm trigger
				ldconfig 
				ldconfig -p | grep -i $1
				echo "***** copy files and links end *****"

				;;
	nm_quad)

			echo "BSP_DIR = $BSP_DIR"

				echo $BOARD_NAME
				
				cd "$BSP_DIR"
				#read -p "Press any key to resume ..."
				
				#(/usr/sbin/dkms status | grep -i ${1} 1>/dev/null 2>&1) || (./driver/dkms.sh install ${1})
				#(/sbin/lsmod | grep -i ${1} 1>/dev/null 2>&1) || (/sbin/modprobe ${1})
				#pushd libload/${1}
				#make install
				#echo "*********make finish***********"
				cp $BSP_DIR/board-nm_quad/VERSION.txt $BSP_DIR/ 
				make -f Makefile-nm_quad driver_host lib_host io_host host_run
				echo "*** driver install ***"
				cd $BSP_DIR/driver
				./dkms.sh install nm_quad
				cd ..
				#ls -l

				udevadm control --reload-rules && udevadm trigger
				echo "***** driver install finished *****"
				echo "***** build_host *****"
				#read -p "Press any key to resume ..."
				#cd $BSP_DIR/io_service/host
				#make clean
				#make libio_host.a
				#cp libio_host.a ../../board-nm_quad/lib
				##ls -l ./build_host/
				#cd $BSP_DIR
				echo "***** host build finish *****"
				##ls -l
				#
				##ls
				##mkdir -p "/usr/local/rc_module/board-${1}"
				##cp -ar "./board-${1}" "/usr/local/rc_module"
				echo "***** build_nm_quad_run *****"
				##read -p "Press any key to resume ..."
				#make -C ./io_service/host all
				#make -C ./run/make nm_quad
				##read -p "Press any key to resume ..."
				echo "***** build_nm_mezzo_run end *****"
				
				echo "***** copy files and links *****"
				echo $(pwd)
				echo $BSP_DIR
				cp -f $BSP_DIR/run/make/nm_quad_run $BSP_DIR/board-nm_quad/bin/
				cp -f $BSP_DIR/firmware/rom_image/nm_quad-firmware.bin $BSP_DIR/board-nm_quad/bin/nm_quad_firmware.bin
				cp -f $BSP_DIR/firmware/nm_quad-init.bin $BSP_DIR/board-nm_quad/bin/nm_quad_init.bin
				cp -f $BSP_DIR/firmware/nm6408-init.bin $BSP_DIR/board-nm_quad/bin/nm6408init.bin
				
				cp -v $BSP_DIR/io_service/host/libio_host.a $BSP_DIR/board-nm_quad/lib
				cp -v $BSP_DIR/io_service/include/io_host.h $BSP_DIR/board-nm_quad/include/
				cp -v $BSP_DIR/io_service/target/libarm_io.a $BSP_DIR/board-nm_quad/lib
				cp -v $BSP_DIR/io_service/target/arm_printf.h $BSP_DIR/board-nm_quad/include/
				cp -v $BSP_DIR/io_service/target/libnmc_io.a $BSP_DIR/board-nm_quad/lib
				cp -v $BSP_DIR/io_service/target/nmc_printf.h $BSP_DIR/board-nm_quad/include/
				
				cp -v $BSP_DIR/libload/nm_quad/libnm_quad_load.so.2.1 $BSP_DIR/board-nm_quad/lib/
				ln -s -f ./libnm_quad_load.so.2.1 $BSP_DIR/board-nm_quad/lib/libnm_quad_load.so.2
				ln -s -f ../lib/libnm_quad_load.so.2 $BSP_DIR/board-nm_quad/bin/libnm_quad_load.so.2
				ln -s -f ./libnm_quad_load.so.2.1 $BSP_DIR/board-nm_quad/lib/libnm_quad_load.so
				ln -s -f ../lib/libnm_quad_load.so $BSP_DIR/board-nm_quad/bin/libnm_quad_load.so
				cp -v $BSP_DIR/libload/nm_quad/nm_quad_load.h $BSP_DIR/board-nm_quad/include/
				cp -v $BSP_DIR/libload/arm/libnm6408load_arm.a $BSP_DIR/board-nm_quad/lib/
				ln -s -f ./libnm6408load_arm.a $BSP_DIR/board-nm_quad/lib/libnm_quad_load_arm.a
				cp -v $BSP_DIR/libload/arm/nm6408load_arm.h $BSP_DIR/board-nm_quad/include/
				ln -s -f ./nm6408load_arm.h $BSP_DIR/board-nm_quad/include/nm_quad_load_arm.h
				cp -v $BSP_DIR/libload/arm/arm_template.x $BSP_DIR/board-nm_quad/
				cp -v $BSP_DIR/libload/nmc/libnm6408load_nmc.a $BSP_DIR/board-nm_quad/lib/
				ln -s -f ./libnm6408load_nmc.a $BSP_DIR/board-nm_quad/lib/libnm_quad_load_nmc.a
				cp -v $BSP_DIR/libload/nmc/nm6408load_nmc.h $BSP_DIR/board-nm_quad/include/
				ln -s -f ./nm6408load_nmc.h $BSP_DIR/board-nm_quad/include/nm_quad_load_nmc.h
				cp -v $BSP_DIR/libload/nmc/nmc_template.x $BSP_DIR/board-nm_quad/
				
				cp -vf $BSP_DIR/nm_quad-2.1.sh /etc/profile.d
				#/usr/bin
				#Add to PATH
				#cp -vf $BSP_DIR/run/make/nm_card_run /usr/bin/
				#cp -vf $BSP_DIR/run/make/nm_card_run /bin/ #f?
				#/usr/include
				cp -vf $BSP_DIR/libload/nm_quad/nm_quad_load.h /usr/include/
				#/usr/lib
				cp -vf $BSP_DIR/libload/nm_quad/libnm_quad_load.so.2.1 /usr/lib/
				ln -s -f ./libnm_quad_load.so.2.1 /usr/lib/libnm_quad_load.so.2
				#ln -s -f ../lib/libnm_card_load.so.2 $BSP_DIR/board-nm_card/bin/libnm_card_load.so.2
				ln -s -f ./libnm_quad_load.so.2.1 /usr/lib/libnm_quad_load.so
				#ln -s -f ../lib/libnm_card_load.so $BSP_DIR/board-nm_card/bin/libnm_card_load.so
				
				#udevadm control --reload-rules && udevadm trigger
				ldconfig 
				ldconfig -p | grep -i $1
				echo "***** copy files and links end *****"

				;;

esac
###################
#if [[ "$1" != "nm_card" ]]; then
#	echo "ERROR: Unknown board!"
#	exit -1 
#	echo "-1"
#if [[ "$1" != "nm_card" ]]; then
#	echo "ERROR: Unknown board!"
#	exit -1 
#	echo "-1"
#fifi



#cd $BSP_DIR/run/make
#     make nm_card
#cd $BSP_DIR




cd "$CUR_DIR"
echo "CUR_DIR = $CUR_DIR"

cp $CUR_DIR/io_service/include/io_host.h ./example/simple
cp $CUR_DIR/io_service/include/io_host.h ./example/use_sync

cd $CUR_DIR/flash_prog


echo $LANG
#if [ $LANG == "en_US.UTF-8" ]

#then unset -v LANG

#echo "unset LANG success!"
#chmod +x $CUR_DIR/flash_prog/*

make host_loader_nm6408

#fi

rm -rf ds-5
rm -f copy_to_flash.c
rm -f host.c
rm -f host.h
rm -f main.c
rm -f Makefile
rm -f nm6408_loader.x
rm -f simple_erase.S
rm -f simple_init.S
rm -f simple_read.S
rm -f simple_write.S
rm -f start.S
ls
#rm -f target.map
#read -p "Press any key to resume ..."
cd ..

cd $CUR_DIR/driver
#echo "******* driver src removed"
	rm -rf $CUR_DIR/driver/dkms
	rm -rf $CUR_DIR/driver/mc12705
	rm -rf $CUR_DIR/driver/nm_card
	rm -rf $CUR_DIR/driver/nm_mezzo
	rm -rf $CUR_DIR/driver/nm_quad
	rm -f $CUR_DIR/driver/nm6408.c
	rm -f $CUR_DIR/driver/nm6408.h
	rm -f $CUR_DIR/driver/nm6408_ioctl.h
	rm -f $CUR_DIR/driver/nm6408_map.h
	rm -f $CUR_DIR/driver/ReadMe.txt
	rm -f $CUR_DIR/driver/upload.sh
cd ..

rm -rf libload
#cd $CUR_DIR/libload
#ls
#rm -rf arm
#rm -rf libelf
#rm -rf mc12705
#rm -rf nmc
#rm -rf nm_card
#rm -rf nm_mezzo
#rm -rf nm_quad
#rm -f ReadMe.txt	
#rm -f libload_nm6408.cpp
#rm -f libload_nm6408.h
#rm -f libload_mutex.c
#rm -f libload_mutex.h
#rm -f libload_edcl.c
#rm -f libload_edcl.h
#rm -f libload_def.h
#rm -f libload.h
#rm -f libload.cpp

#cd ..

rm -rf $CUR_DIR/io_service


#echo "******* libload src removed"

#rm -rf $CUR_DIR/libload
ls
rm -rf $CUR_DIR/run
rm -rf $CUR_DIR/firmware
rm -f $CUR_DIR/nm_card-2.1.sh
rm -f $CUR_DIR/nm_mezzo-2.1.sh
rm -f $CUR_DIR/nm_quad-2.1.sh
rm -f $CUR_DIR/source_set_env.sh
rm -f $CUR_DIR/make_distro-NeuroMezzanine.sh 
rm -f $CUR_DIR/make_distro-mc12705.sh
rm -f $CUR_DIR/make_distro-nm_card.sh
rm -f $CUR_DIR/make_distro-nm_mezzo.sh
rm -f $CUR_DIR/make_distro-nm_quad.sh
rm -f $CUR_DIR/setup.sh
rm -f $CUR_DIR/source_set_env.sh
rm -f $CUR_DIR/Makefile-NeuroMezzanine
rm -f $CUR_DIR/Makefile-nm_card
rm -f $CUR_DIR/Makefile-nm_mezzo
rm -f $CUR_DIR/Makefile-nm_quad

rm -f $CUR_DIR/VERSION.txt
#cd $CUR_DIR/run
#echo "******* run"
#cd ..

#rm -rf driver
#rm -rf libload
#rm -rf run 
#rm -rf io_service
echo "***** Install temperature monitor *****"

cd nm6408-temperature-monitor
   ./build.sh
   ls | grep -v bin | xargs rm -rf
   rm -rf .*
cd ..
cp -r /usr/local/rc_module/nm6408-temperature-monitor/* /usr/local/rc_module/temperature_monitor/
rm -rf nm6408-temperature-monitor
echo "***** Installation complete *****"
exit 0

