#!/bin/bash -e

 if [ "$1" != "mc12705" ] && [ "$1" != "nm_card" ] && [ "$1" != "nm_mezzo" ] && [ "$1" != "nm_quad" ] && [ "$1" != "neuro_mezzanine" ]; then
	echo "ERROR: Unknown board!"
	exit -1
fi
T_BIN=bin_trg
H_BIN=bin_$1
mkdir -p $T_BIN
mkdir -p $H_BIN
mkdir -p src/MAP_DMA

pushd ./src

# clean all
make -f Makefile_host clean
make -f Makefile_arm clean
make -f Makefile_nmc clean
# make all
make -f Makefile_arm 
make -f Makefile_nmc 
make -f Makefile_host $1

popd

cp run* $H_BIN/.


