#!/bin/bash

rm -f include/*
rm -f lib/*

mkdir -p include/
mkdir -p lib/

LIB="lib"
INC="include"


# LIBS

#host
# ./libload/${1}/${LNAME}
# ./io_service/host/libio_host.a
#cp ../../../libload/${1}/${LNAME}   ${LIB}/.
cp ../../../io_service/host/libio_host.a   ${LIB}/.

#arm
# ./io_service/target/libarm_io.a
# ./libload/arm/libnm6408load_arm.a
cp ../../../io_service/target/libarm_io.a   ${LIB}/.
cp ../../../libload/arm/libnm6408load_arm.a   ${LIB}/.

#nmc
# ./io_service/target/libnmc_io.a
# ./libload/nmc/libnm6408load_nmc.a
cp ../../../io_service/target/libnmc_io.a   ${LIB}/.
cp ../../../libload/nmc/libnm6408load_nmc.a   ${LIB}/.

# INCLUDES

#host
# ./io_service/include/io_host.h
# ./io_service/include/nm6408wrap.h
# ./libload/${1}/${INAME}
cp ../../../io_service/include/io_host.h   ${INC}/.
cp ../../../io_service/include/nm6408wrap.h   ${INC}/.
#cp ../../../libload/${1}/${INAME}   ${INC}/.

#arm
# ./io_service/target/arm_printf.h  - not needed
# ./libload/arm/nm6408load_arm.h
cp ../../../libload/arm/nm6408load_arm.h   ${INC}/.

#nmc
# ./io_service/target/nmc_printf.h   - not needed
# ./libload/nmc/nm6408load_nmc.h
cp ../../../libload/nmc/nm6408load_nmc.h   ${INC}/.

