#!/bin/bash -e

 if [ "$1" != "mc12705" ] && [ "$1" != "nm_card" ] && [ "$1" != "nm_mezzo" ] && [ "$1" != "nm_quad" ] && [ "$1" != "neuro_mezzanine" ]; then
	echo "ERROR: Unknown board!"
	exit -1
fi

ERROR=0

#pushd ./bin

for i in 1 2 3 4 5 6 7 8 9 0; do
  rm -f out*
  echo "EEEE $i EEEE"
  ./tc_printf.out ${1} -1 -1 0 0 1 0 2 0 3 0 -1 0 0 1 1 1 2 1 3 1 -1 1 0 2 1 2 2 2 3 2 -1 2 0 3 1 3 2 3 3 3 -1 3 0x60
  ls -l out*
  COUNT=`grep -r 'Afte All Sync' out* | sed -n '$='`
  if [[ $? -ne 0 || $COUNT -ne 21 ]]; then
    echo ERROR
    ERROR=1
    break 
  fi
done

#popd

if [[ $ERROR -eq 1 ]]; then
  exit 1
else
  ./check.sh
  exit 0
fi

