/*
    arm_printf test
*/
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "nm6408load_arm.h"

int main ()
{
	int i=0,j=0, res;
	int size = 1, s=0x100;
	int loop, stp=0, D;
	char arr[0x300];
#define StepSync	0x8
#define StepMax		0x300
//--------------------------
	loop = StepMax / StepSync;
	size=acl_hostSync(loop);
	D = size/(StepSync*4);;
	printf("** ARM%d ****\n %s D=0x%x size=0x%x\n", acl_getClusterID(), "Before StepSync",D,size);
	for(i=1; i<=StepMax; i++){
		if ((i%(StepSync)) == 0){
			acl_hostSync(4444);
			stp=0;
		}
		if(stp == 0) s= size;
		else if(stp < (StepSync/2)) s+= D;
		else if(stp == (StepSync/2)) s= size;
		else s-= D;  // stp > (StepSync/2)
		memset(arr,'k',s);
		arr[s]=0;
		res = printf("**0x%x ARM%d %s%x\n", i+1, acl_getClusterID(), arr, s);
		if (res <0) {
			printf("**0x%x ARM%d ERROR *****\n", i+1, acl_getClusterID());
			break;
		}
		stp++;
	}
	acl_hostSync(10);
	printf("** ARM%d ****\n %s\n", acl_getClusterID(), "Afte All Sync");

    return 0;
}
