#!/bin/bash
 
if [ "$1" != "mc12705" ] && [ "$1" != "nm_card" ] && [ "$1" != "nm_mezzo" ] && [ "$1" != "nm_quad" ] && [ "$1" != "neuro_mezzanine" ]; then
	echo "ERROR: Unknown board!"
	exit -1
fi

rm -f out*
 ./tc_stdio.out ${1} 0 0 1 0 2 0 3 0 -1 2 -1 3 -1 0 -1 1
 
 RES=0
 ls -l F_*
 ls -l out* | grep "out_" || RES=1
grep -r "ERROR" out* >NULL && RES=1
grep -r "FAIL" out* >NULL && RES=1
grep -r "PASS" out* >NULL || RES=1

if [ $RES -eq 0 ]; then
		echo "TEST ***** PASS ******"
else
        echo "TEST *****FAIL ******"
fi