//
// BoardTtype Setting
//

#if defined(MC12705)

#include <mc12705load.h>

#define DEVICE_NAME "mc12705"
#define DEVICE_NAME_STR "MC127.05"

#elif defined(NM_CARD)

#include <nm_card_load.h>

#define DEVICE_NAME "nm_card_"
#define DEVICE_NAME_STR "NM_Card"

#elif defined(NM_MEZZO)

#include <nm_mezzo_load.h>

#define DEVICE_NAME "nm_mezzo_"
#define DEVICE_NAME_STR "NM_Mezzo"

#elif defined(NM_QUAD)

#include "nm_quad_load.h"

#define DEVICE_NAME "nm_quad_"
#define DEVICE_NAME_STR "NM_Quad"

#elif defined(NEURO_MEZZANINE)

#include "neuro_mezzanine_load.h"

#define DEVICE_NAME "neuro_mezzanine_"
#define DEVICE_NAME_STR "Neuro_Mezzanine"

#else

#error "Unknow device!"

#endif


