#!/bin/bash

RES=0
if [ $2 -ge 0 ]; then  # nmc
	trg=nmc
	TRG=NMC
	tm=abc
else
	trg=arm
	TRG=ARM
	tm=elf
fi

trg_out=run_${trg}_out

echo TEST ${trg}_prog_t$1.$tm 
./tc_stdio $1 $2> $trg_out

grep "$TRG STDIO TEST FAIL" $trg_out && RES=1
grep "$TRG STDIO TEST PASS" $trg_out || RES=1

if [ $RES -eq 0 ]; then
  echo "TEST ${trg}_prog_t$1.$tm ****** PASS"
else
  echo "TEST ${trg}_prog_t$1.$tm ****** FAIL"
fi