/*
   nmc_stdio open and close
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL = 0;
	int st=345;
	int fd_1, fd_2, flag, fd_test;
	char ch_flag[64];
	char *F1 = "F_WITH_MODE";
	char *F2 = "F_WITHOUT_MODE";
	
	flag = O_CREAT|O_TRUNC|O_RDWR|O_BINARY;
	strcpy(ch_flag,"O_CREAT|O_TRUNC|O_RDWR|O_BINARY");
	
	trg_hostSync(0x10);
	printf("%s STDIO open with mode START \nfile %s flags=%s mode=%o\n",
			CORE_TYPE,F1,ch_flag,S_IREAD | S_IWRITE);
	fd_1=open(F1, flag, S_IREAD | S_IWRITE);
	if(fd_1 <0){
		printf("%s STDIO open with mode ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO open with mode file %s PASS \n",CORE_TYPE,F1);
	}
	trg_hostSync(0x20);
	printf("%s STDIO open without mode START file %s \n",CORE_TYPE,F2);
	fd_2=open(F2,  flag);
	if(fd_2 <0){
		printf("%s STDIO open without mode ERROR  errno=%d  \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO open without mode file %s PASS  \n",CORE_TYPE,F2);
	}

	trg_hostSync(0x30);
	printf("%s STDIO close(fd_1)  START \n",CORE_TYPE);
	st=close(fd_1);
	if(st != 0){
		printf("%s STDIO close(fd_1) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fd_1) PASS  st=%d \n",CORE_TYPE,st);
	}
	trg_hostSync( 0x40);
	printf("%s STDIO close(fd_2)  START \n",CORE_TYPE);
	st=345;
	st=close(fd_2);
	if(st != 0){
		printf("%s STDIO close(fd_2) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fd_2) PASS  st=%d \n",CORE_TYPE,st);
	}

	trg_hostSync(0x50);
	if(FAIL) printf("%s STDIO TEST FAIL \n",CORE_TYPE);
	else printf("%s STDIO TEST PASS \n",CORE_TYPE);

    return 0;
}
