/*
  trg_stdio test  
		int remove(const char *pathname);  
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	char arr_in[32], arr_out[32];
	int fd, flag_d;
	int fr, flag_r;
	char ch_flag_d[64];
	char ch_flag_r[64];
	char *old = "F_TMP";
		
	flag_d = O_CREAT|O_TRUNC|O_RDWR;
	strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
	flag_r = O_RDONLY|O_BINARY;
	strcpy(ch_flag_r,"O_RDONLY|O_BINARY");
	
	trg_hostSync(0x10);
	printf("%s STDIO open START file %s\n",CORE_TYPE,old);
	fd=open(old,flag_d,S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open file %s PASS \n",CORE_TYPE,old);
	}
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	st=close(fd);
	if(st != 0){
		printf("%s STDIO close(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO close(fd) PASS  st=%d\n",CORE_TYPE,st);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO remove START %s \n",CORE_TYPE,old);
	res = remove(old);
	if(res <0){
		printf("%s STDIO remove ERROR  errno=%d FAIL\n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO remove PASS \n",CORE_TYPE);
	}
	
	trg_hostSync(0x30);
	printf("%s STDIO open START file %s\n",CORE_TYPE,old);
	fr=open(old,flag_r);
	if(fr >0){
		printf("%s STDIO opened file=%s FAIL \n",CORE_TYPE,old);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO file=%s is not opened PASS \n",CORE_TYPE,old);
	
	trg_hostSync(0x40);

	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
