/*
  trg_stdio test  rename
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	char arr_in[32], arr_out[32];
	int fd, flag_d;
	int fr, flag_r;
	char ch_flag_d[64];
	char ch_flag_r[64];
	char *old = "F_OLD";
	char *new = "F_NEW";
	
	flag_d = O_CREAT|O_TRUNC|O_RDWR;
	strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
	flag_r = O_RDONLY|O_BINARY;
	strcpy(ch_flag_r,"O_RDONLY|O_BINARY");
		
	trg_hostSync(0x10);
	unlink(new);
	printf("%s STDIO OPEN START file %s\n",CORE_TYPE,old);
	fd=open(old,flag_d,S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO OPEN ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO OPEN file %s PASS \n",CORE_TYPE,old);

	printf("%s STDIO CLOSE(fd) START\n",CORE_TYPE);
	if((st=close(fd)) != 0){
		printf("%s STDIO CLOSE(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO CLOSE(fd) PASS  st=%d\n",CORE_TYPE,st);

	trg_hostSync( 0x20);
	printf("%s STDIO RENAME START %s to %s\n",CORE_TYPE,old,new);
	res = rename(old,new);
//	link(old,new);
	if(res <0){
		printf("%s STDIO RENAME ERROR  errno=%d FAIL\n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO RENAME PASS \n",CORE_TYPE);

	trg_hostSync(0x30);
	printf("%s STDIO CHECK RENAME BY OPEN NEW AND OLD\n",CORE_TYPE);
	printf("%s STDIO OPEN START file %s\n",CORE_TYPE,new);
	if((fr=open(new,flag_r)) <0){
		printf("%s STDIO not opened file by new name  errno=%d FIAL\n",CORE_TYPE,
				errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO OPEN file=%s PASS PASS\n",CORE_TYPE,new);
	
	trg_hostSync(0x40);
	printf("%s STDIO OPEN START file %s\n",CORE_TYPE,old);
	if((fr=open(old,flag_r)) >0){
		printf("%s STDIO opened file by old name  FIAL\n",CORE_TYPE);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO RENAME PASS\n",CORE_TYPE,old);
	
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
