#include "init_code.h"
#include "libload_def.h"
#include "nm6408load_nmc.h"

#ifdef __cplusplus
extern "C" {
#endif

void __attribute__((noreturn)) stop(void) asm("stop");
void stop(void)
{
	struct libload_top		*ll_top = (void *)(LIBLOAD_DATA_ADDR >> 2);
	volatile struct libload_format	*ll_format;
	register int			gr7 asm("gr7");
	int				tmp, result;
	int				cid, nid;

	result = gr7;

	cid = ncl_getClusterID();
	nid = ncl_getCoreID();

	ll_format = &ll_top->cluster[cid].nmc[nid];

	ll_format->result = result;
	tmp = ll_format->result; // barrier

	asm("pswr clear 0x11E0;":::"memory");
	*((volatile unsigned int *)0x0002040C) = 0x0FFFFFFF;
	*((volatile unsigned int *)0x0002041C) = 0x0FFFFFFF;
	*((volatile unsigned int *)0x00020404) = 0x0FFFFFFF;
	asm("intr clear 0x03C0;":::"memory");

	ll_format->status = PROGRAM_STOPPED;
	tmp = ll_format->status; // barrier

	while (1) { asm("halt;"); };
}

#ifdef __cplusplus
};
#endif
